#include "stdafx.h"
#include "ArcShape.h"



namespace sf
{

	ArcShape::ArcShape(float arc, float int_radius, float ext_radius, unsigned int pointCount)
	{
		m_arc = arc;
		m_intrad = int_radius;
		m_extrad = ext_radius;
		m_pointcount = pointCount;
		ArcShape::update();
	}
	void ArcShape::redraw(float arc, float int_radius, float ext_radius, unsigned int pointCount)
	{
		m_arc = arc;
		m_intrad = int_radius;
		m_extrad = ext_radius;
		m_pointcount = pointCount;
		ArcShape::update();
	}
	float ArcShape::getAngle()
	{
		return m_arc;
	}
	void ArcShape::setFillColor(const Color &color)
	{
		m_fillColor = color;
		updateFillColor();
	}

	void ArcShape::draw(RenderTarget& target, RenderStates states) const
	{
		states.transform *= getTransform();
		states.texture = NULL;
		target.draw(m_vertices, states);
	}
	void ArcShape::update()
	{
		m_vertices.clear();
		m_vertices.setPrimitiveType(TrianglesStrip);
		m_vertices.resize(2 * (m_pointcount + 1));
		for (int i = 0; i <= m_pointcount; i++)
		{
			m_vertices[i * 2].position = Vector2f(m_extrad*cos((m_arc / m_pointcount)*i), m_extrad*sin((m_arc / m_pointcount)*i));
			m_vertices[i * 2].color = m_fillColor;
			m_vertices[i * 2 + 1].position = Vector2f(m_intrad*cos((m_arc / m_pointcount)*i), m_intrad*sin((m_arc / m_pointcount)*i));
			m_vertices[i * 2 + 1].color = m_fillColor;
		}
	}
	void ArcShape::updateFillColor()
	{
		for (size_t i = 0; i < m_vertices.getVertexCount(); ++i)
			m_vertices[i].color = m_fillColor;
	}

};
