#pragma once
#ifndef SFML_ARCSHAPE_HPP
#define SFML_ARCSHAPE_HPP

#include "stdafx.h"
#include "ArcShape.h"
#include <SFML\Graphics.hpp>

namespace sf
{
	class ArcShape :public Drawable, public Transformable
	{
	public:
		explicit ArcShape(float arc, float int_radius, float ext_radius, unsigned int pointCount=30);
		void redraw(float arc, float int_radius, float ext_radius, unsigned int pointCount=30);
		float getAngle();
		void setFillColor(const Color& fillColor);
	private:
		virtual void draw(RenderTarget&, RenderStates) const;
		void update();
		void updateFillColor();
		VertexArray m_vertices;
		Color m_fillColor;
		float m_arc;
		float m_intrad;
		float m_extrad;
		unsigned int m_pointcount;
	};
}
#endif