#pragma once
#include <iostream>
#include <SFML\Graphics.hpp>
#include <SFML\System.hpp>
#include "VectorMath.h"

const int SCREEN_WIDTH = 1280;
const int SCREEN_HEIGHT = 720;

const int MENU_SIZE = 240;

const int BALL_RADIUS = 10;
const int ARENA_RADIUS = 350;
const int PAD_DISTANCE = 60;
const int PAD_WIDTH = 16;
const float PAD_ARC = 0.5f;

const float SPEED = 15.f;

const sf::Color BACK_COLOR(254, 252, 250, 255);
const sf::Color CLEAR_COLOR(76, 74, 72, 1);
const sf::Color MENUOUT_COLOR(81, 92, 107, 255);
const sf::Color MENUBACK_COLOR(104, 118, 138, 255);
const sf::Color BORDERS_COLOR(105, 121, 126, 255);
const sf::Color BALL_COLOR(255, 0, 255, 255);
const sf::Color PAD1_COLOR(0, 0, 255, 127);
const sf::Color PAD2_COLOR(255, 0, 0, 127);

class GameBall
{
public:
	GameBall(unsigned int radius);
	
	void setPosition(sf::Vector2f position);

	void resetPosition();

	sf::Vector2f getPosition();

	sf::Vector2f getPositionCentered();

	sf::Vector2f getVelocity();

	void setVelocity(sf::Vector2f velocity);

	void updatePosition();

	void setState(int state);
	
	int getState();

	void draw(sf::RenderWindow& win);

	bool checkCollisionRectangle(sf::Shape& collider);

	bool checkCollisionPaddle(float rad_in, float rad_out);
	
	float computeAngle();
	
private:
	float m_Angle();
	sf::CircleShape m_graphic;
	sf::Vector2f m_velocity;
	int m_state;
};

